<?php

namespace App\Models;

use App\Enums\ProductStockQuality;
use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Attributes\Scope;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Spatie\Image\Enums\Fit;
use Spatie\MediaLibrary\HasMedia;
use Spatie\MediaLibrary\InteractsWithMedia;
use Spatie\MediaLibrary\MediaCollections\Models\Media;

#[Appends(['stock_type_label', 'formatted_total'])]
#[Guarded(['id'])]
class Restock extends Model implements HasMedia
{
    use HasFactory, InteractsWithMedia, SoftDeletes;

    protected function casts(): array
    {
        return [
            'stock_type' => ProductStockQuality::class,
            'total' => 'integer',
        ];
    }

    protected function stockTypeLabel(): Attribute
    {
        return Attribute::make(
            get: fn () => $this->stock_type->label(),
        );
    }

    protected function formattedTotal(): Attribute
    {
        return Attribute::make(
            get: fn () => 'Rp '.number_format($this->total, 0, ',', '.'),
        );
    }

    #[Scope]
    protected function good(Builder $query): void
    {
        $query->where('stock_type', ProductStockQuality::GOOD);
    }

    #[Scope]
    protected function reject(Builder $query): void
    {
        $query->where('stock_type', ProductStockQuality::REJECT);
    }

    public function createdBy(): BelongsTo
    {
        return $this->belongsTo(User::class, 'created_by_id');
    }

    public function restockItems(): HasMany
    {
        return $this->hasMany(RestockItem::class);
    }

    public function registerMediaCollections(): void
    {
        $this->addMediaCollection('photos');
    }

    public function registerMediaConversions(?Media $media = null): void
    {
        $this->addMediaConversion('thumb')
            ->fit(Fit::Contain, 150, 150);
    }
}
